![](intro.jpg)

# ▲ PRE-REQUISITES

    node >= 6.0 (https://nodejs.org/en/download/current/)
    npm  >= 3.0 (pre-installed by node)
    yarn        (npm install yarn -g)

# ▲ INSTALL DEPENDENCIES AND BUILD

    yarn
    yarn start

# ▲ LOCAL DEBUGGING

In the `awv3` directory run:

    yarn run debug

And in the target projects webpack.config.js, alias to `awv3` given that it exists in the parent folder:

    alias: {
        awv3: fs.existsSync('./../awv3/dist') ? path.resolve('./../awv3/dist') : 'awv3',
    },

# ▲ POLYFILLS NEEDED

- requestidlecallback
- es6-promise
- isomorphic-fetch
- perfnow
- event-listener-with-options/js/polyfill
- various es6 polyfills (either provided by corejs or babel-polyfill)

# ▲ SWITCH CAM/CONTROLLS PER APP

```js
import { actions } from 'awv3/session/store/globals'

session.dispatch(actions.setControls('trackball'))
session.dispatch(actions.setCamera('orthographic'))
```
