export var back = {
  in: function _in(k) {
    var s = 1.70158;
    return k * k * ((s + 1) * k - s);
  },
  out: function out(k) {
    var s = 1.70158;
    return --k * k * ((s + 1) * k + s) + 1;
  },
  inOut: function inOut(k) {
    var s = 1.70158 * 1.525;
    if ((k *= 2) < 1) return 0.5 * (k * k * ((s + 1) * k - s));
    return 0.5 * ((k -= 2) * k * ((s + 1) * k + s) + 2);
  }
};
export var bounce = {
  in: function _in(k) {
    return 1 - outward(1 - k);
  },
  out: function out(k) {
    if (k < 1 / 2.75) return 7.5625 * k * k;else if (k < 2 / 2.75) return 7.5625 * (k -= 1.5 / 2.75) * k + 0.75;else if (k < 2.5 / 2.75) return 7.5625 * (k -= 2.25 / 2.75) * k + 0.9375;else return 7.5625 * (k -= 2.625 / 2.75) * k + 0.984375;
  },
  inOut: function inOut(k) {
    if (k < 0.5) return inward(k * 2) * 0.5;
    return outward(k * 2 - 1) * 0.5 + 0.5;
  }
};
export var circular = {
  in: function _in(k) {
    return 1 - Math.sqrt(1 - k * k);
  },
  out: function out(k) {
    return Math.sqrt(1 - --k * k);
  },
  inOut: function inOut(k) {
    if ((k *= 2) < 1) return -0.5 * (Math.sqrt(1 - k * k) - 1);
    return 0.5 * (Math.sqrt(1 - (k -= 2) * k) + 1);
  }
};
export var cubic = {
  in: function _in(k) {
    return k * k * k;
  },
  out: function out(k) {
    return --k * k * k + 1;
  },
  inOut: function inOut(k) {
    if ((k *= 2) < 1) return 0.5 * k * k * k;
    return 0.5 * ((k -= 2) * k * k + 2);
  }
};
export var elastic = {
  in: function _in(k) {
    var s,
        a = 0.1,
        p = 0.4;
    if (k === 0) return 0;
    if (k === 1) return 1;

    if (!a || a < 1) {
      a = 1;
      s = p / 4;
    } else s = p * Math.asin(1 / a) / (2 * Math.PI);

    return -(a * Math.pow(2, 10 * (k -= 1)) * Math.sin((k - s) * (2 * Math.PI) / p));
  },
  out: function out(k) {
    var s,
        a = 0.1,
        p = 0.4;
    if (k === 0) return 0;
    if (k === 1) return 1;

    if (!a || a < 1) {
      a = 1;
      s = p / 4;
    } else s = p * Math.asin(1 / a) / (2 * Math.PI);

    return a * Math.pow(2, -10 * k) * Math.sin((k - s) * (2 * Math.PI) / p) + 1;
  },
  inOut: function inOut(k) {
    var s,
        a = 0.1,
        p = 0.4;
    if (k === 0) return 0;
    if (k === 1) return 1;

    if (!a || a < 1) {
      a = 1;
      s = p / 4;
    } else s = p * Math.asin(1 / a) / (2 * Math.PI);

    if ((k *= 2) < 1) return -0.5 * (a * Math.pow(2, 10 * (k -= 1)) * Math.sin((k - s) * (2 * Math.PI) / p));
    return a * Math.pow(2, -10 * (k -= 1)) * Math.sin((k - s) * (2 * Math.PI) / p) * 0.5 + 1;
  }
};
export var exponential = {
  in: function _in(k) {
    return k === 0 ? 0 : Math.pow(1024, k - 1);
  },
  out: function out(k) {
    return k === 1 ? 1 : 1 - Math.pow(2, -10 * k);
  },
  inOut: function inOut(k) {
    if (k === 0) return 0;
    if (k === 1) return 1;
    if ((k *= 2) < 1) return 0.5 * Math.pow(1024, k - 1);
    return 0.5 * (-Math.pow(2, -10 * (k - 1)) + 2);
  }
};
export var linear = function linear(k) {
  return k;
};
export var quadratic = {
  in: function _in(k) {
    return k * k;
  },
  out: function out(k) {
    return k * (2 - k);
  },
  inOut: function inOut(k) {
    if ((k *= 2) < 1) return 0.5 * k * k;
    return -0.5 * (--k * (k - 2) - 1);
  }
};
export var quartic = {
  in: function _in(k) {
    return k * k * k * k;
  },
  out: function out(k) {
    return 1 - --k * k * k * k;
  },
  inOut: function inOut(k) {
    if ((k *= 2) < 1) return 0.5 * k * k * k * k;
    return -0.5 * ((k -= 2) * k * k * k - 2);
  }
};
export var quintic = {
  in: function _in(k) {
    return k * k * k * k * k;
  },
  out: function out(k) {
    return --k * k * k * k * k + 1;
  },
  inOut: function inOut(k) {
    if ((k *= 2) < 1) return 0.5 * k * k * k * k * k;
    return 0.5 * ((k -= 2) * k * k * k * k + 2);
  }
};
export var sinusoidal = {
  in: function _in(k) {
    return 1 - Math.cos(k * Math.PI / 2);
  },
  out: function out(k) {
    return Math.sin(k * Math.PI / 2);
  },
  inOut: function inOut(k) {
    return 0.5 * (1 - Math.cos(Math.PI * k));
  }
};