import _createClass from "@babel/runtime/helpers/createClass";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import * as THREE from 'three';
import Events from './events';
import unpack from 'awv3-protocol/unpack';
var defaults = {
  unpack: unpack,
  resolution: 1,
  gpu: false,
  up: [0, 0, 1],
  //TODO: Add default camera position?
  stats: false,
  debug: false,
  fadeDuration: 600,
  interpolatePoints: false,
  clone: true,
  ambientIntensity: 1.0,
  renderOrder: {
    Mesh: 0,
    LineSegments: 100,
    Point: 1000
  },
  updateView: {
    focus: false,
    zoom: false,
    rotate: false,
    layers: false
  },
  materials: {
    lazy: false,
    multi: true,
    lineDistances: true,
    shadows: false,
    lights: true
  },
  lineShader: THREE.LineBasicMaterial,
  lineShaderOptions: {
    transparent: true,
    fog: false
  },
  meshShader: THREE.MeshPhysicalMaterial,
  meshShaderOptions: {
    transparent: true,
    fog: false,
    polygonOffset: true,
    polygonOffsetFactor: 1,
    polygonOffsetUnits: 1,
    emissive: new THREE.Color(0),
    reflectivity: 0,
    metalness: 0.6,
    roughness: 0.6,
    clearCoat: 1,
    clearCoatRoughness: 0.7,
    envMapIntensity: 1
  }
};

var Defaults =
/*#__PURE__*/
function (_Events) {
  _inheritsLoose(Defaults, _Events);

  function Defaults() {
    var _this;

    _this = _Events.call(this) || this;

    var _loop = function _loop(key) {
      Object.defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), key, {
        configurable: true,
        get: function get() {
          return defaults[key];
        },
        set: function set(value) {
          return _this.emit(Defaults.Events.Changed, key, defaults[key] = value);
        }
      });
    };

    for (var key in defaults) {
      _loop(key);
    }

    return _this;
  }

  _createClass(Defaults, [{
    key: "all",
    get: function get() {
      return defaults;
    }
  }]);

  return Defaults;
}(Events);

Defaults.Events = {
  Changed: 'Changed'
};
var instance = new Defaults();
export default instance;