import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _class, _class2, _temp;

import React from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import Plugin from '../../session/plugin';
import Dimensions from '../dimensions/';
var resources = ['extrusion'].reduce(function (prev, item) {
  var _objectSpread2;

  return _objectSpread({}, prev, (_objectSpread2 = {}, _objectSpread2[item] = require('!!url-loader!awv3-icons/32x32/' + item + '.png'), _objectSpread2));
}, {});
var BooleanOp = (_dec = connect(function (state, props) {
  var tree = state.connections[props.connection].tree;
  var feature = tree[props.id];
  return {
    feature: feature
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(BooleanOp, _React$Component);

  function BooleanOp(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _this.setBody1 = function (arg1) {
      var session = _this.context.plugin.session;

      if (session) {
        var object = session.selector.selectedObjects[0];

        var Body1 = _objectSpread({}, _this.state.Body1, {
          value: object ? object.material[0].meta.owner : []
        });

        _this.setState({
          Body1: Body1
        });
      }
    };

    _this.setBody2 = function (arg1) {
      var session = _this.context.plugin.session;

      if (session) {
        var members = session.selector.selectedObjects.map(function (el) {
          return {
            expression: '',
            type: 'id',
            value: el.material[0].meta.owner,
            visible: 1
          };
        });

        var Body2 = _objectSpread({}, _this.state.Body2, {
          members: members
        });

        _this.setState({
          Body2: Body2
        });
      }
    };

    _this.apply = function () {
      var featureId = _this.context.plugin.connection.activeFeature;
      var boolOpType = _this.state.type;
      var firstId = _this.state.Body1.value;

      var otherIds = _this.state.Body2.members.map(function (el) {
        return el.value;
      });

      var command = [{
        'Feature.UpdateBooleanOperation': [featureId, boolOpType, [firstId].concat(otherIds)]
      }];

      _this.context.plugin.connection.execute(command);
    };

    _this.state = props.feature.members;
    _this.state.type = props.feature.class.slice(3);
    return _this;
  }

  var _proto = BooleanOp.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(props) {
    if (props.feature === undefined) return;
    var editMode = props.feature.class !== 'CC_BooleanOperation';
    this.setState({
      editMode: editMode
    });
  };

  _proto.render = function render() {
    var _this$state$Body,
        _this2 = this;

    var canBeApplied = ((_this$state$Body = this.state.Body1) === null || _this$state$Body === void 0 ? void 0 : _this$state$Body.value) !== 0 && this.state.Body2.members.length > 0 && this.state.type !== 'BooleanOperation';
    return React.createElement("group", {
      format: "Table"
    }, React.createElement("dropdown", {
      name: "type",
      items: ['Union', 'Intersection', 'Subtraction'],
      value: this.state.type,
      onValue: function onValue(type) {
        return _this2.setState({
          type: type
        });
      }
    }), React.createElement("selection", {
      name: "body1",
      types: ['Mesh', 'Model'],
      limit: "1",
      onItems: this.setBody1,
      items: this.state.Body1.value == 0 ? [] : [this.state.Body1.value]
    }), React.createElement("selection", {
      name: "body2",
      types: ['Mesh', 'Model'],
      onItems: this.setBody2,
      items: this.state.Body2.members.map(function (el) {
        return el.value;
      })
    }), React.createElement("button", {
      name: "Update",
      flex: 0,
      color: "blue",
      onLastEvent: this.apply,
      disabled: !canBeApplied
    }));
  };

  return BooleanOp;
}(React.Component), _class2.contextTypes = {
  plugin: PropTypes.object
}, _temp)) || _class);

var Feature =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(Feature, _Plugin);

  function Feature(session, args) {
    return _Plugin.call(this, session, _objectSpread({
      type: args.feature.class,
      icon: args.name.toLowerCase(),
      resources: resources
    }, args)) || this;
  }

  var _proto2 = Feature.prototype;

  _proto2.render = function render() {
    return React.createElement("group", null, React.createElement(BooleanOp, {
      connection: this.connection.id,
      id: this.feature
    }), React.createElement("spacer", null), React.createElement("link", {
      value: this.dimensions.id,
      collapsable: true
    }));
  };

  _proto2.onEnabled = function onEnabled() {
    this.dimensions = new Dimensions(this.session, {
      name: 'Dimensions',
      collapsed: true,
      closeable: false,
      parent: this.id
    });
    this.dimensions.enabled = true;
  };

  _proto2.onDisabled = function onDisabled() {
    this.dimensions.destroy();
  };

  return Feature;
}(Plugin);

Feature.contextMenuItems = _objectSpread({}, Plugin.contextMenuItems, {
  customItem: {
    name: 'Extrude custom item',
    callback: function callback(feature) {
      console.log('!!!! Custom Item callback called');
      console.log(feature);
    }
  }
});
export { Feature as default };