import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _extends from "@babel/runtime/helpers/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _construct from "@babel/runtime/helpers/construct";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import * as THREE from 'three';
import React from 'react';
import PropTypes from 'prop-types';
import Plugin from '../../session/plugin';
import Graphics from './graphics';
import Object3 from '../../three/object3';
import Hud from '../../core/hud';
import { actions as connectionActions } from 'awv3/session/store/connections';
import { getPositionFromSelection } from './helpers';
import { calculateRotationMatrix } from './calculations';

var Root =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Root, _React$Component);

  function Root(_props, context) {
    var _this;

    _this = _React$Component.call(this) || this;
    _this.state = {
      rotx: 0,
      roty: 0,
      rotz: 0,
      offset: '0,0,0',
      activeSelector: 0
    };

    _this.setOffset = function (vec) {
      return _this.context.plugin.translate({
        offset: _construct(THREE.Vector3, vec.split(','))
      });
    };

    _this.setRot = function (val, which) {
      _this.rotation[which] = val * Math.PI / 180;

      _this.context.plugin.translate({
        rotation: _this.rotation
      });
    };

    _this.update =
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee() {
      var _assertThisInitialize2, _assertThisInitialize3;

      var _assertThisInitialize, graphics, connection, props, featureId, rootId, result, xAxis, yAxis, position, geomInfo;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _assertThisInitialize = _assertThisInitialized(_assertThisInitialized(_this)), graphics = _assertThisInitialize.graphics, connection = _assertThisInitialize.connection, props = _assertThisInitialize.props;
              featureId = props.feature;

              if (!!props.feature) {
                _context.next = 10;
                break;
              }

              //If feature is undefined, create new coordinate system
              rootId = connection.activeRoot || connection.tree.root;
              _context.next = 6;
              return connection.execute([{
                'Feature.CreateNamedCoordSystem': [rootId, 'CSYS', {
                  x: 0.0,
                  y: 0.0,
                  z: 0.0
                }, {
                  x: 1.0,
                  y: 0.0,
                  z: 0.0
                }, {
                  x: 0.0,
                  y: 1.0,
                  z: 0.0
                }]
              }]);

            case 6:
              result = _context.sent;

              if (!(result.errors.filter(function (e) {
                return e.errorState > 1;
              }).length !== 0)) {
                _context.next = 9;
                break;
              }

              return _context.abrupt("return", console.log('error'));

            case 9:
              featureId = result.results[0].result;

            case 10:
              xAxis = new THREE.Vector3(), yAxis = new THREE.Vector3();
              graphics.matrix.extractBasis(xAxis, yAxis, new THREE.Vector3());
              position = new THREE.Vector3().setFromMatrixPosition(graphics.matrix);
              _context.next = 15;
              return connection.execute([{
                'Common.SetObjectCoordSystem': [featureId, position, xAxis, yAxis]
              }]);

            case 15:
              geomInfo = {
                position: position,
                xAxis: _this.context.plugin.xAxis,
                yAxis: _this.context.plugin.yAxis
              };
              (_assertThisInitialize2 = _assertThisInitialized(_assertThisInitialized(_this))) === null || _assertThisInitialize2 === void 0 ? void 0 : (_assertThisInitialize3 = _assertThisInitialize2.hooks) === null || _assertThisInitialize3 === void 0 ? void 0 : _assertThisInitialize3.update({
                featureId: featureId,
                geomInfo: geomInfo
              });
              _this.context.plugin.sourceMatrix = _this.context.plugin.graphics.matrix;

            case 18:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    _this.rotate = function (selection, whichAxis) {
      if (selection.length) {
        var _this$context$plugin$;

        var meta = _this.context.session.selector.selectedMaterials[0].meta;
        if (meta.type === 'line') var dir = meta.end.clone().sub(meta.start.clone()).normalize();else if (meta.type === 'plane') var dir = meta.normal.clone();
        var rotationMatrix = calculateRotationMatrix(whichAxis, dir);

        _this.context.plugin.translate((_this$context$plugin$ = {}, _this$context$plugin$[whichAxis + "Axis"] = rotationMatrix, _this$context$plugin$));
      }
    };

    _this.connection = context.plugin.connection;
    _this.session = context.session;
    _this.pool = context.plugin.pool;
    _this.view = context.plugin.view;
    _this.graphics = _props.graphics;
    _this.rotation = new THREE.Euler();
    _this.hooks = _props.hooks;
    return _this;
  }

  var _proto = Root.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$state = this.state,
        activeSelector = _this$state.activeSelector,
        rotx = _this$state.rotx,
        roty = _this$state.roty,
        rotz = _this$state.rotz,
        offset = _this$state.offset;
    var sliderProps = {
      max: 360,
      step: 10,
      positions: {
        0: '0°',
        90: '90°',
        180: '180°',
        270: '270°',
        360: '360°'
      }
    };
    return React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Origin",
      active: activeSelector === 0,
      types: ['Region', 'Mesh', 'LineSegments'],
      limit: 3,
      onItems: function onItems(items) {
        if (items.length) {
          var _getPositionFromSelec;

          var position = _this2.context.plugin.position;
          position = (_getPositionFromSelec = getPositionFromSelection(_this2.context.session.selector.selectedMaterials)) !== null && _getPositionFromSelec !== void 0 ? _getPositionFromSelec : position;

          _this2.context.plugin.translate({
            position: position
          });
        }
      }
    }), React.createElement("selection", {
      active: activeSelector === 1,
      name: "Axis",
      types: ['Mesh', 'LineSegments'],
      limit: 1,
      onItems: function onItems(items) {
        if (items.length) {
          _this2.rotate(items, 'x');

          _this2.setState({
            activeSelector: 2
          });
        }
      }
    }), React.createElement("selection", {
      name: "Secondary",
      active: activeSelector === 2,
      types: ['Mesh', 'LineSegments'],
      limit: 1,
      onItems: function onItems(items) {
        if (items.length) {
          _this2.rotate(items, 'y');

          _this2.setState({
            activeSelector: undefined
          });
        }
      }
    }), React.createElement("slider", _extends({
      name: "Rotation X"
    }, sliderProps, {
      value: rotx,
      onValue: function onValue(v) {
        return _this2.setRot(v, 'x');
      }
    })), React.createElement("slider", _extends({
      name: "Rotation Y"
    }, sliderProps, {
      value: roty,
      onValue: function onValue(v) {
        return _this2.setRot(v, 'y');
      }
    })), React.createElement("slider", _extends({
      name: "Rotation Z"
    }, sliderProps, {
      value: rotz,
      onValue: function onValue(v) {
        return _this2.setRot(v, 'z');
      }
    })), React.createElement("group", {
      name: "Offset",
      format: "Rows"
    }, React.createElement("input", {
      format: "Vector",
      value: offset,
      onValue: this.setOffset
    }), React.createElement("button", {
      name: this.props.feature ? 'Update' : 'Create',
      flex: 0,
      color: "blue",
      onLastEvent: this.update
    })));
  };

  return Root;
}(React.Component);

Root.contextTypes = {
  session: PropTypes.object,
  plugin: PropTypes.object
};

var Csys =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(Csys, _Plugin);

  var _proto2 = Csys.prototype;

  _proto2.getCoordinates = function getCoordinates() {
    var coords = this.feature ? this.tree[this.feature].coordinateSystem : [[0, 0, 0], [1, 0, 0], [0, 1, 0], [0, 0, 1]];
    this.position = _construct(THREE.Vector3, coords[0]);
    this.rotation = new THREE.Euler();

    var x = _construct(THREE.Vector3, coords[1]);

    var y = _construct(THREE.Vector3, coords[2]);

    this.xAxis = new THREE.Matrix4().makeBasis(x, y, x.clone().cross(y));
    this.yAxis = new THREE.Matrix4();
    this.offset = new THREE.Vector3();
  };

  function Csys(session, _args2) {
    var _this3$pool$createInt;

    var _this3;

    _this3 = _Plugin.call(this, session, _objectSpread({
      type: 'Csys',
      icon: 'csys',
      resources: {
        csys: require('!!url-loader!awv3-icons/32x32/csys.png')
      }
    }, _args2)) || this;

    _this3.translate = function (args) {
      var _ref3;

      // Update local values
      if (args) Object.entries(args).forEach(function (_ref2) {
        var key = _ref2[0],
            value = _ref2[1];
        return value && _this3[key] !== value && (_this3[key] = value);
      });
      var newMatrix = new THREE.Matrix4().setPosition(_this3.position).multiply(_this3.xAxis).multiply(_this3.yAxis).multiply(new THREE.Matrix4().makeRotationFromEuler(_this3.rotation)).multiply((_ref3 = new THREE.Matrix4()).makeTranslation.apply(_ref3, _this3.offset.toArray()));
      _this3.graphics.matrix = newMatrix;

      _this3.graphics.applyMatrix(_this3.pool.matrixWorld);

      _this3.graphics.matrixAutoUpdate = false;

      _this3.view.invalidate();
    };

    _this3.setInitialPosition = function (geomInfo) {
      _this3.xAxis = geomInfo.xAxis;
      _this3.yAxis = geomInfo.yAxis;
      _this3.position = geomInfo.position;

      _this3.translate();
    };

    _this3.graphics = new Graphics(_assertThisInitialized(_assertThisInitialized(_this3)));
    _this3.hud = new Hud(_this3.view);

    _this3.view.addHud(_this3.hud);

    _this3.hud.scene.add(_this3.graphics);

    _this3.getCoordinates();

    _this3.translate();

    _this3.pool.createInteraction().on((_this3$pool$createInt = {}, _this3$pool$createInt[Object3.Events.Lifecycle.Rendered] = _this3.onRender.bind(_assertThisInitialized(_assertThisInitialized(_this3))), _this3$pool$createInt), {
      sync: true
    });

    if (_this3.feature) {
      _this3.visibleSubscription = _this3.connection.observe(function (state) {
        var _ref4, _state$tree$_this3$fe;

        return (_ref4 = (_state$tree$_this3$fe = state.tree[_this3.feature]) === null || _state$tree$_this3$fe === void 0 ? void 0 : _state$tree$_this3$fe.visible) !== null && _ref4 !== void 0 ? _ref4 : false;
      }, function (visible) {
        if (_this3.tree[_this3.feature] === undefined) // TODO: why visibility called after deletion
          return;
        _this3.graphics.visible = Boolean(visible);

        _this3.getCoordinates();

        _this3.translate();

        _this3.connection.updateView();
      }, {
        fireOnStart: true
      });
    } else {
      _this3.graphics.visible = true;

      _this3.connection.updateView();
    }

    return _this3;
  }

  _proto2.onRender = function onRender() {
    if (this.graphics.visible) {
      var position = new THREE.Vector3();
      this.graphics.getWorldPosition(position);
      var approxScale = this.view.calculateScaleFactor(position, 2);
      this.graphics.updateScale(approxScale);
    }
  };

  _proto2.willBeDestroyed = function willBeDestroyed() {
    this.hud.destroy();
  };

  _proto2.onDestroyed = function onDestroyed() {
    this.visibleSubscription && this.visibleSubscription();
    this.visibleSubscription = undefined;
    this.graphics.destroy();
  };

  _proto2.onEnabled = function onEnabled() {
    this.graphics.setActive(true);
    this.sourceMatrix = this.graphics.matrix;
    this.view.invalidate();
  };

  _proto2.onDisabled = function onDisabled() {
    this.graphics.setActive(false);
    this.graphics.matrix = this.sourceMatrix;
    this.graphics.matrixAutoUpdate = false;
    this.view.invalidate();
  };

  _proto2.render = function render() {
    return React.createElement(Root, _extends({
      graphics: this.graphics
    }, this.props));
  };

  _proto2.switchToFeature = function switchToFeature(featureId) {
    featureId === undefined && (featureId = this.feature);
    var tree = this.connection.tree;
    var root = this.connection.activeRoot || tree.root;
    var features = tree[root].features;
    if (features.indexOf(featureId) != -1) this.store.dispatch(connectionActions.setActiveFeature(this.connection.id, featureId)); //TODO: else throw error.
  };

  return Csys;
}(Plugin);

Csys.persistent = true;
export { Csys as default };