import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import Plugin from '../../session/plugin';
import { buildFeaturePath } from '../../session/helpers';
import { Button } from '../../session/elements';
import { actions as connectionActions } from '../../session/store/connections';
var resources = ['isometric'].reduce(function (prev, item) {
  var _objectSpread2;

  return _objectSpread({}, prev, (_objectSpread2 = {}, _objectSpread2[item] = require('!!url-loader!awv3-icons/32x32/' + item + '.png'), _objectSpread2));
}, {});

var DebugSeq =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(DebugSeq, _Plugin);

  function DebugSeq(session, args) {
    var _this;

    _this = _Plugin.call(this, session, _objectSpread({
      type: 'DebugSeq',
      icon: 'isometric',
      resources: resources
    }, args)) || this;
    _this.button = new Button(_assertThisInitialized(_assertThisInitialized(_this)), {
      name: 'Debug Step'
    });

    _this.addElement(_this.button);

    return _this;
  }

  var _proto = DebugSeq.prototype;

  _proto.onEnabled = function onEnabled() {
    var _this2 = this;

    this.resetElements();
    this.button.observe(function (state) {
      return state.lastEvent;
    }, function (event) {
      var connection = _this2.session.activeConnection;
      var path = buildFeaturePath(connection.tree, connection.tree.root);

      _this2.session.dispatch(connectionActions.execute(connection.id, path + ".OperationSequence.DebugSequence();"));
    });
  };

  return DebugSeq;
}(Plugin);

export { DebugSeq as default };