import _construct from "@babel/runtime/helpers/construct";
import Angular from './angular';
import Linear from './linear';
import Radial from './radial';
import Diametral from './diametral';
export default function Graphics(className) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  switch (className) {
    case 'CC_AngularDimension':
    case 'CC_AngularFeatureDimension':
    case 'CC_AngularRefDimension':
      return _construct(Angular, args);

    case 'CC_LinearDimension':
    case 'CC_LinearFeatureDimension':
    case 'CC_LinearRefDimension':
      return _construct(Linear, args);

    case 'CC_RadialDimension':
    case 'CC_RadialFeatureDimension':
    case 'CC_RadialRefDimension':
      return _construct(Radial, args);

    case 'CC_DiameterDimension':
    case 'CC_DiameterFeatureDimension':
    case 'CC_DiameterRefDimension':
      return _construct(Diametral, args);
  }
} // Support hot reloading

if (module.hot) module.hot.accept(['./angular', './linear', './radial', './diametral']);