import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import * as THREE from 'three';
import BaseGraphics from './base';
import { setMaterialMeta } from './index'; // New dashed lines:

import { LineMaterial } from '../../../three/lines/LineMaterial';
import { LineGeometry } from '../../../three/lines/LineGeometry';
import { Line2 } from '../../../three/lines/Line2'; // Old lines:

var geometry = new THREE.BoxBufferGeometry(1, 1, 0);
var material = new THREE.MeshBasicMaterial({
  color: 0x3378a2,
  side: THREE.DoubleSide,
  polygonOffset: true,
  polygonOffsetFactor: -1,
  polygonOffsetUnits: -5
});

var Line =
/*#__PURE__*/
function (_BaseGraphics) {
  _inheritsLoose(Line, _BaseGraphics);

  function Line(session, sketch) {
    var _this;

    _this = _BaseGraphics.call(this) || this; // Old lines:

    _this.localMesh = new THREE.Mesh(geometry, material.clone());
    _this.localMesh.type = 'SketcherMesh'; // New dashed lines:

    /*
    var positions = []
    var colors = []
    positions.push(0, 0, 0, 0, 0, 0)
    colors.push(1, 1, 1, 1, 1, 1)
    let geometry = new LineGeometry()
    geometry.setPositions(positions)
    geometry.setColors(colors)
    let material = new LineMaterial({
      color: 0x3378a2,
      linewidth: 5, // in pixels
      vertexColors: THREE.VertexColors,
      //resolution:  // to be set by renderer, eventually
      dashed: true,
      dashSize: 1,
      gapSize: 0.5,
      polygonOffset: true,
      polygonOffsetFactor: -1,
      polygonOffsetUnits: -5,
    })
    material.defines.USE_DASH = ''
    this.localMesh = new Line2(geometry, material)
    this.localMesh.computeLineDistances()
    this.localMesh.scale.set(1, 1, 1)
    material.resolution.set(window.innerWidth, window.innerHeight) // resolution of the viewport
    */

    _this.localMesh.material.meta = {};
    _this.localMesh.material.meta.material = setMaterialMeta(material);
    _this.localMesh.material.meta.type = 'line';
    if (sketch) // For temp lines (when drawing)
      _this.localMesh.material.meta.parent = sketch.id;

    _this.add(_this.localMesh);

    return _this;
  }

  var _proto = Line.prototype;

  _proto.updateFromGeomParams = function updateFromGeomParams(geomParams) {
    _BaseGraphics.prototype.updateFromGeomParams.call(this, geomParams);

    var dir = geomParams.end.clone().sub(geomParams.start).normalize();
    var length = geomParams.start.distanceTo(geomParams.end); // Old lines:

    this.localMesh.position.lerpVectors(geomParams.start, geomParams.end, 0.5);
    this.localMesh.quaternion.setFromUnitVectors(new THREE.Vector3(1, 0, 0), dir);
    this.localMesh.scale.set(Math.max(length, 1e-3), geomParams.scale, 1e-3);
    this.updateMetaBox(); // New dashed lines:

    /*    let start = geomParams.start
    let end = geomParams.end
    this.localMesh.geometry.setPositions([start.x, start.y, start.z, end.x, end.y, end.z])
    this.localMesh.computeLineDistances()*/
  };

  return Line;
}(BaseGraphics);

export { Line as default };