import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import Object3 from '../../../three/object3';
import HoverHandler from './hover';
import ConstraintGenerator from '../constraint/generator';
import { SplitAllCurves, SplitCurvesMergeBack, Return, Sequence } from '../command/lowlevel';
import { removeCommands } from '../command/highlevel';

var TrimHandler =
/*#__PURE__*/
function (_HoverHandler) {
  _inheritsLoose(TrimHandler, _HoverHandler);

  function TrimHandler() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _HoverHandler.call.apply(_HoverHandler, [this].concat(args)) || this;

    _this.sketcher.multiRunner.run({
      command: 'Execute',
      task: Sequence(Return(SplitAllCurves(_this.sketcher.activeSketch))).unparse()
    }).then(function () {
      for (var _iterator = _this.sketch.descendants, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var object = _ref;
        if (!_this.filterObjectsWithInteraction(object)) continue;

        if (!object.isTrimmedPart()) {
          object.graphics.visible = false;
        }
      }
    });

    return _this;
  }

  var _proto = TrimHandler.prototype;

  _proto.filterObjectsWithInteraction = function filterObjectsWithInteraction(object) {
    return object.id !== this.sketch.id && object.graphics !== undefined && !object.isConstraint();
  };

  _proto.addInteraction = function addInteraction(object) {
    if (!this.filterObjectsWithInteraction(object)) return;

    if (object.isTrimmedPart() && !object.isPoint()) {
      _HoverHandler.prototype.addInteraction.call(this, object);
    }
  }; // override because base method calls removeInteraction based on interactions.keys instead of trimObjects.keys


  _proto.removeInteractions = function removeInteractions() {
    var _this2 = this;

    this.sketcher.multiRunner.run({
      command: 'Execute',
      task: Sequence(Return(SplitCurvesMergeBack(this.sketcher.activeSketch))).unparse()
    }).then(function () {
      var constraintGenerator = new ConstraintGenerator(_this2.sketcher);
      var newConstraintsCommand = [];

      for (var _iterator2 = _this2.sketch.descendants, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
        var _ref2;

        if (_isArray2) {
          if (_i2 >= _iterator2.length) break;
          _ref2 = _iterator2[_i2++];
        } else {
          _i2 = _iterator2.next();
          if (_i2.done) break;
          _ref2 = _i2.value;
        }

        var obj = _ref2;

        if (obj.isCurve()) {
          newConstraintsCommand = newConstraintsCommand.concat(constraintGenerator.generateImpliedConstraints(obj));
        }
      }

      var command = Sequence.apply(void 0, newConstraintsCommand);
      if (newConstraintsCommand.length > 0) _this2.sketcher.run(command);
    });
  };

  _proto[Object3.Events.Interaction.Clicked] = function (object, hitObject) {
    this.sketcher.multiRunner.run({
      command: 'Execute',
      task: Sequence(removeCommands(this.activeSketch, object)).unparse()
    });
  };

  return TrimHandler;
}(HoverHandler);

export { TrimHandler as default };