import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _class, _class2, _temp, _class3, _class4, _temp2;

import React from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';
import Plugin from '../../session/plugin';
import Graphics from './graphics';
import { actions as globalsActions } from '../../session/store/globals';
import { actions as elementsActions } from '../../session/store/elements';
var resources = ['plane'].reduce(function (prev, item) {
  var _objectSpread2;

  return _objectSpread({}, prev, (_objectSpread2 = {}, _objectSpread2[item] = require('!!url-loader!awv3-icons/32x32/' + item + '.png'), _objectSpread2));
}, {});
/*WP_XYPLANE = 0,
WP_XZPLANE = 1,
WP_YZPLANE = 2,
WP_USERDEFINED = 3,

WP_PLANE = 10,
WP_EDGEPOINT = 11,
WP_3POINTS = 12,
WP_POINTNORMAL = 13,
WP_POINTFACE = 14,
WP_LINEPLANEANGLE = 16*/

var READONLY_WORKPLANE_TYPES = new Map([[0, 'XYPLANE'], [1, 'XZPLANE'], [2, 'YZPLANE'], [15, 'WP_2CURVES']]);
var WORKPLANE_TYPES = new Map([[3, 'USERDEFINED'], [10, 'WP_PLANE'], [11, 'WP_EDGEPOINT'], [12, 'WP_3POINTS'], [13, 'WP_POINTNORMAL'], [14, 'WP_POINTFACE'], [16, 'WP_LINEPLANEANGLE']]);

function getTypeName(typeId) {
  if (READONLY_WORKPLANE_TYPES.has(typeId)) return READONLY_WORKPLANE_TYPES.get(typeId);
  if (WORKPLANE_TYPES.has(typeId)) return WORKPLANE_TYPES.get(typeId);
}

function getTypeId(typeName) {
  var i = Array.from(READONLY_WORKPLANE_TYPES.values()).indexOf(typeName);
  var key = -1;

  if (i !== -1) {
    key = Array.from(READONLY_WORKPLANE_TYPES.keys())[i];
    return key;
  }

  i = Array.from(WORKPLANE_TYPES.values()).indexOf(typeName);

  if (i !== -1) {
    key = Array.from(WORKPLANE_TYPES.keys())[i];
    return key;
  }
}

var Root = (_dec = connect(function (state, props) {
  return {
    feature: state.connections[state.globals.activeConnection].tree[props.featureId]
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Root, _React$Component);

  function Root(props, context) {
    var _this;

    _this = _React$Component.call(this) || this;

    _this.componentWillReceiveProps = function (props) {
      _this.setState(_this.context.plugin.getFeatureGUIData());

      _this.context.plugin.updateGraphics();
    };

    _this.applyChanges = function () {
      _this.context.plugin.applyFromGUI(_this.state);
    };

    _this.update = function (event) {
      return event.key === 'Enter' && _this.applyChanges();
    };

    _this.setType = function (typeName) {
      var newTypeId = getTypeId(typeName);

      var featureData = _this.context.plugin.getFeatureGUIData();

      if (featureData.type === newTypeId) {
        _this.setState(featureData);
      } else {
        var defaultState = {
          origin: '0,0,0',
          normal: '1,0,0',
          offset: 0,
          angle: 0,
          references: []
        };

        _this.setState(_objectSpread({}, defaultState, {
          type: newTypeId
        }));
      }
    };

    _this.setPlane = function (refIdx) {
      var object = _this.session.selector.selectedObjects[0];
      if (object === undefined) return;
      var meta = object.userData.meta;
      var value;

      if (meta === undefined) {
        value = _this.session.selector.selectedMaterials[0].meta.id;
      } else {
        value = meta.id;
      }

      _this.setReference(refIdx, value);
    };

    _this.setReference = function (refIndex, value) {
      var selectedMaterials = _this.session.selector.selectedMaterials;

      if (value === undefined && selectedMaterials.length > 0) {
        value = selectedMaterials[0].meta.id;
      }

      var selectedMaterial = selectedMaterials[0];

      var references = _this.state.references.concat();

      while (references.length < refIndex) {
        // TODO: is it really needed?
        references.push(undefined);
      }

      var ref = {
        value: value,
        type: selectedMaterial.meta.type,
        meta: _objectSpread({}, selectedMaterial.meta)
      };

      if (_this.state.type === getTypeId('WP_LINEPLANEANGLE') && refIndex === 0 && value !== null) {
        var _references$;

        var parent = _this.session.tree[selectedMaterial.meta.parent];

        if (parent !== undefined && parent.class === 'CC_Sketch') {
          references[1] = {
            value: parent.id,
            type: 'sketch'
          };
        } else if (((_references$ = references[1]) === null || _references$ === void 0 ? void 0 : _references$.type) === 'sketch') {
          references[1] = undefined;
        }
      }

      references[refIndex] = ref;

      _this.setState({
        references: references
      });
    };

    _this.setActiveSelectionElement = function (selectionId) {
      _this.context.plugin.store.dispatch(globalsActions.setActiveSelection(selectionId));
    };

    _this.state = context.plugin.getFeatureGUIData(); // this.connection = context.plugin.connection

    _this.session = context.plugin.session;
    return _this;
  }

  var _proto = Root.prototype;

  _proto.setReferenceAndNextElement = function setReferenceAndNextElement(selected, refIndex, nextSelectionID) {
    if (selected.length !== 0) {
      if (this.session.selector.selectedObjects[0].type === 'Mesh') {
        this.setPlane(refIndex);
      } else {
        this.setReference(refIndex);
      }

      switch (this.session.elements[nextSelectionID].type) {
        case 'Selection':
          if (this.state.references[refIndex + 1] === undefined) {
            this.setActiveSelectionElement(nextSelectionID);
          } else {
            this.setActiveSelectionElement(undefined);
          }

          break;

        case 'Input':
          this.setActiveSelectionElement(undefined);
          this.context.plugin.store.dispatch(elementsActions.update(nextSelectionID, {
            focus: true
          }));
          break;
      }
    } else {
      var references = this.state.references.concat();
      references[refIndex] = undefined;

      if (this.state.type === getTypeId('WP_LINEPLANEANGLE') && refIndex === 0 && references[1].type === 'sketch') {
        references[1] = undefined;
      }

      this.setState({
        references: references
      });
    }
  };

  _proto.render = function render() {
    var _references$2,
        _this$session$tree$pa,
        _this2 = this;

    var _this$state = this.state,
        type = _this$state.type,
        origin = _this$state.origin,
        normal = _this$state.normal,
        offset = _this$state.offset,
        angle = _this$state.angle,
        references = _this$state.references;
    var ref0 = references[0] ? [references[0].value] : [];
    var ref1 = references[1] ? [references[1].value] : [];
    var ref2 = references[2] ? [references[2].value] : [];
    var parent = (_references$2 = references[0]) === null || _references$2 === void 0 ? void 0 : _references$2.meta.parent;
    var readonly = ((_this$session$tree$pa = this.session.tree[parent]) === null || _this$session$tree$pa === void 0 ? void 0 : _this$session$tree$pa.class) === 'CC_Sketch';
    var offsetField = React.createElement("input", {
      name: "Offset",
      value: offset,
      format: "Number",
      onValue: function onValue(x) {
        _this2.setState({
          offset: x
        });
      },
      ref: "offsetInput"
    });
    return React.createElement("group", {
      format: "Table"
    }, React.createElement("dropdown", {
      name: "Type",
      items: Array.from(WORKPLANE_TYPES.values()),
      value: getTypeName(type),
      onValue: this.setType,
      disabled: this.state.disabled
    }), type === getTypeId('USERDEFINED') && React.createElement("group", {
      format: "Table"
    }, React.createElement("input", {
      name: "origin",
      value: origin,
      format: "Vector",
      onValue: function onValue(origin) {
        return _this2.setState({
          origin: origin
        });
      },
      onLastEvent: this.update
    }), React.createElement("input", {
      name: "Normal",
      value: normal,
      format: "Vector",
      onValue: function onValue(normal) {
        return _this2.setState({
          normal: normal
        });
      },
      onLastEvent: this.update
    }), offsetField), type === getTypeId('WP_PLANE') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Plane",
      types: ['Mesh'],
      limit: 1,
      onItems: function onItems(plane1) {
        _this2.setReferenceAndNextElement(plane1, 0, _this2.refs.offsetInput.id);
      },
      items: ref0
    }), offsetField), type === getTypeId('WP_LINEPLANEANGLE') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Line",
      types: ['LineSegments', 'SketcherMesh'],
      whitelist: ['SketcherMesh'],
      limit: 1,
      onItems: function onItems(line1) {
        _this2.setReferenceAndNextElement(line1, 0, _this2.refs.planeSelection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Plane",
      types: ['Mesh'],
      limit: 1,
      onItems: function onItems(plane1) {
        _this2.setReferenceAndNextElement(plane1, 1, _this2.refs.angleInput.id);
      },
      items: ref1,
      ref: "planeSelection",
      readonly: readonly
    }), React.createElement("input", {
      name: "Angle",
      value: angle,
      format: "Number",
      onValue: function onValue(x) {
        _this2.setState({
          angle: x
        });
      },
      ref: "angleInput"
    })), type === getTypeId('WP_2CURVES') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Curve1",
      types: ['LineSegments'],
      limit: 1,
      onItems: function onItems(curve1) {
        _this2.setReferenceAndNextElement(curve1, 0, _this2.refs.curve2Selection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Curve2",
      types: ['LineSegments'],
      limit: 1,
      onItems: function onItems(curve2) {
        _this2.setReferenceAndNextElement(curve2, 1, undefined);
      },
      items: ref1,
      ref: "curve2Selection"
    })), type === getTypeId('WP_3POINTS') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Point 1",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(point1) {
        _this2.setReferenceAndNextElement(point1, 0, _this2.refs.point2Selection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Point 2",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(point2) {
        _this2.setReferenceAndNextElement(point2, 1, _this2.refs.point3Selection.id);
      },
      items: ref1,
      ref: "point2Selection"
    }), React.createElement("selection", {
      name: "Point 3",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(point3) {
        _this2.setReferenceAndNextElement(point3, 2, _this2.refs.offsetInput.id);
      },
      items: ref2,
      ref: "point3Selection"
    }), offsetField), type === getTypeId('WP_EDGEPOINT') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Edge",
      types: ['LineSegments'],
      limit: 1,
      onItems: function onItems(item) {
        _this2.setReferenceAndNextElement(item, 0, _this2.refs.pointSelection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Point",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(vertex) {
        _this2.setReferenceAndNextElement(vertex, 1, _this2.refs.offsetInput.id);
      },
      items: ref1,
      ref: "pointSelection"
    }), offsetField), type === getTypeId('WP_POINTNORMAL') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Point",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(vertex) {
        _this2.setReferenceAndNextElement(vertex, 0, _this2.refs.edgeSelection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Edge",
      types: ['LineSegments'],
      limit: 1,
      onItems: function onItems(item) {
        _this2.setReferenceAndNextElement(item, 1, _this2.refs.offsetInput.id);
      },
      items: ref1,
      ref: "edgeSelection"
    }), offsetField), type === getTypeId('WP_POINTFACE') && React.createElement("group", {
      format: "Table"
    }, React.createElement("selection", {
      name: "Point",
      types: ['Region'],
      limit: 1,
      onItems: function onItems(vertex) {
        _this2.setReferenceAndNextElement(vertex, 0, _this2.refs.faceSelection.id);
      },
      items: ref0
    }), React.createElement("selection", {
      name: "Face",
      types: ['Mesh'],
      limit: 1,
      onItems: function onItems(item) {
        _this2.setReferenceAndNextElement(item, 1, _this2.refs.offsetInput.id);
      },
      items: ref1,
      ref: "faceSelection"
    }), offsetField), !this.state.disabled && React.createElement("button", {
      name: "Update",
      flex: 0,
      color: "blue",
      onLastEvent: this.applyChanges
    }));
  };

  return Root;
}(React.Component), _class2.contextTypes = {
  plugin: PropTypes.object
}, _temp)) || _class);

function validated(target) {
  var updateCommand = target.updateCommand;
  updateCommand === undefined && console.error('updateCommand should not be undefined');
  target.prototype.validate === undefined && console.error('validate method should be implemented');
  target.prototype.convertGUIToClassCad === undefined && (target.prototype.convertGUIToClassCad = function (GUIProps) {
    return [this.feature].concat(Object.values(GUIProps));
  });
  target.prototype.getFeatureGUIData === undefined && (target.prototype.getFeatureGUIData = function () {
    return _objectSpread({}, this.tree[this.feature]);
  });

  target.prototype.applyFromGUI = function (GUIProps) {
    var _this3 = this;

    var warnings = this.validate(GUIProps);

    if (warnings.length !== 0) {
      warnings.forEach(function (warningMsg) {
        _this3.session.dispatch(globalsActions.showWarning(warningMsg));
      });
      return;
    }

    var updateCommandObj = {};
    updateCommandObj[updateCommand] = this.convertGUIToClassCad(GUIProps);
    return this.connection.execute([updateCommandObj]);
  };
}

var Workplane = validated(_class3 = (_temp2 = _class4 =
/*#__PURE__*/
function (_Plugin) {
  _inheritsLoose(Workplane, _Plugin);

  function Workplane(session, args) {
    var _this4;

    _this4 = _Plugin.call(this, session, _objectSpread({
      type: 'Workplane',
      icon: 'plane',
      resources: resources
    }, args)) || this;

    _this4.updateGraphics = function () {
      return _this4.workplane.updateFromState(_this4.tree[_this4.feature]);
    };

    _this4.workplane = new Graphics(_assertThisInitialized(_assertThisInitialized(_this4)));
    _this4.pool.measurable = true;

    _this4.pool.add(_this4.workplane);

    _this4.visibleSubscription = _this4.connection.observe(function (state) {
      var _ref, _state$tree$_this4$fe;

      return (_ref = (_state$tree$_this4$fe = state.tree[_this4.feature]) === null || _state$tree$_this4$fe === void 0 ? void 0 : _state$tree$_this4$fe.visible) !== null && _ref !== void 0 ? _ref : false;
    }, function (visible) {
      if (_this4.tree[_this4.feature] === undefined) // TODO: why visibility called after deletion
        return;
      _this4.workplane.visible = Boolean(visible);

      _this4.updateGraphics();
    }, {
      fireOnStart: true
    });
    return _this4;
  }

  var _proto2 = Workplane.prototype;

  _proto2.render = function render() {
    return React.createElement(Root, {
      featureId: this.feature
    });
  };

  _proto2.onDestroyed = function onDestroyed() {
    this.visibleSubscription && this.visibleSubscription();
    this.visibleSubscription = undefined;
    this.workplane.destroy();
  };

  _proto2.convertGUIToClassCad = function convertGUIToClassCad(props) {
    var type = props.type,
        offset = props.offset,
        angle = props.angle,
        name = props.name;
    var references = props.references.map(function (el) {
      return el.value;
    });
    var originArray = props.origin.split(',').map(function (val) {
      return parseInt(val);
    });
    var origin = {
      x: originArray[0],
      y: originArray[1],
      z: originArray[2]
    };
    var normalArray = props.normal.split(',').map(function (val) {
      return parseFloat(val);
    });
    var normal = {
      x: normalArray[0],
      y: normalArray[1],
      z: normalArray[2]
    };
    var local = true; //TODO

    return [this.feature, type, references, type === getTypeId('WP_LINEPLANEANGLE') ? angle : offset, name, origin, normal, local];
  };

  _proto2.getReferencesForGUI = function getReferencesForGUI(classCADRefs, type) {
    var _this5 = this;

    var refObjs = classCADRefs.members.map(function (refMember) {
      return _this5.session.tree[refMember.value];
    });
    var sketchId = undefined;
    var result = refObjs.map(function (refObj) {
      var refMembers = refObj.members;
      var reference = {};

      switch (refObj.class) {
        case 'CC_VertexReference':
          reference = {
            value: refMembers.vertexId.value,
            type: 'point'
          };
          break;

        case 'CC_FaceReference':
          reference = {
            value: refMembers.faceId.value,
            type: 'plane'
          };
          break;

        case 'CC_EdgeReference':
          reference = {
            value: refMembers.edgeId.value,
            type: 'line'
          };
          break;

        case 'CC_Line':
          reference = {
            value: refObj.id,
            type: 'line'
          };

          if (type === getTypeId('WP_LINEPLANEANGLE')) {
            var parent = _this5.session.tree[refObj.parent];

            if (parent !== undefined && parent.class === 'CC_Sketch') {
              sketchId = refObj.parent; //TODO: Session didn't contains meta for sketch objects, so create ugly fake object.

              reference.meta = {
                parent: sketchId
              };
            }
          }

          break;

        case 'CC_WorkPlane':
          if (type === getTypeId('WP_LINEPLANEANGLE') && sketchId !== undefined) reference = {
            value: sketchId,
            type: 'sketch' //TODO: add meta info for sketch.

          };else reference = {
            value: refObj.id,
            type: 'plane'
          };
          break;

        case 'CC_Sketch':
          reference = {
            value: refObj.id,
            type: 'sketch'
          };
          break;

        default:
          console.error('unknown type');
          return {
            value: 0,
            type: 'error'
          };
      }

      reference.meta === undefined && (reference.meta = _this5.session.getMetaInfo(reference.value));
      return reference;
    });
    return result;
  };

  _proto2.getFeatureGUIData = function getFeatureGUIData() {
    var featureObj = this.tree[this.feature];
    var result = {
      type: featureObj.members.Type.value,
      origin: featureObj.members.Position.value.join(','),
      normal: featureObj.members.Normal.value.join(','),
      offset: featureObj.members.Offset.value,
      angle: featureObj.members.Angle.value * (180 / Math.PI)
    };
    result.references = this.getReferencesForGUI(featureObj.members.References, result.type);
    result.disabled = false;
    READONLY_WORKPLANE_TYPES.forEach(function (typeName, typeId) {
      result.disabled = result.disabled || typeId === result.type;
    });
    return result;
  };

  _proto2.validate = function validate(GUIProps) {
    var warnings = [];
    var type = GUIProps.type,
        origin = GUIProps.origin,
        normal = GUIProps.normal,
        offset = GUIProps.offset,
        name = GUIProps.name,
        references = GUIProps.references;

    if (type === getTypeId('WP_LINEPLANEANGLE')) {
      var faceRef = undefined;
      var lineRef = undefined;
      var sketchRef = undefined;

      for (var i = 0; i < references.length; ++i) {
        var refObj = references[i];
        refObj.type === 'plane' && (faceRef = refObj);
        refObj.type === 'line' && (lineRef = refObj);
        refObj.type === 'sketch' && (sketchRef = refObj);
      }

      faceRef === undefined && sketchRef == undefined && warnings.push('The plane should be selected');
      lineRef === undefined && warnings.push('The straight line should be selected');

      if (faceRef !== undefined && lineRef !== undefined) {
        var pointStartVec = faceRef.meta.pointOnPlane.clone().sub(lineRef.meta.start);
        var pointEndVec = faceRef.meta.pointOnPlane.clone().sub(lineRef.meta.end); // compare calculated normals with a tolerance, because the sent normal from server is rounded to 3 decimal places.

        var tolerance = 0.01;
        var isLineOnPlane = Math.abs(faceRef.meta.normal.dot(pointStartVec)) <= tolerance && Math.abs(faceRef.meta.normal.dot(pointEndVec)) <= tolerance;
        !isLineOnPlane && warnings.push('The line should lies within the plane');
      }
    }

    return warnings;
  };

  return Workplane;
}(Plugin), _class4.persistent = true, _class4.updateCommand = 'Feature.UpdateWorkPlane', _temp2)) || _class3;

export { Workplane as default };