import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import without from 'lodash/without';
import { types as pluginTypes } from './plugins';
import { types as ConnectionTypes } from './connections';
export var reducer = function reducer(state, _ref) {
  if (state === void 0) {
    state = {
      plugins: [],
      connections: []
    };
  }

  var type = _ref.type,
      payload = _objectWithoutPropertiesLoose(_ref, ["type"]);

  switch (type) {
    case ConnectionTypes.register:
      return _objectSpread({}, state, {
        connections: state.connections.concat([payload.id])
      });

    case ConnectionTypes.unregister:
      var objects = Array.isArray(payload.ids) ? payload.ids : [payload.ids];
      return _objectSpread({}, state, {
        connections: without.apply(void 0, [state.connections].concat(objects))
      });

    default:
      return state;
  }
};