import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import omitBy from 'lodash/omitBy';
import isObject from 'lodash/isObject';
import { mixin } from '../lifecycle';
var scope = 'elements';
export var base = mixin(scope, element);
export var types = _objectSpread({}, base.types, {
  addChild: scope + "/addChild",
  removeChild: scope + "/removeChild",
  removeAllChilds: scope + "/removeAllChilds",
  event: scope + "/event"
});
export var actions = _objectSpread({}, base.actions, {
  addChild: function addChild(id, child, from) {
    if (from === void 0) {
      from = 'children';
    }

    return {
      type: types.addChild,
      id: id,
      child: child,
      from: from
    };
  },
  removeChild: function removeChild(id, child, from) {
    if (from === void 0) {
      from = 'children';
    }

    return {
      type: types.removeChild,
      id: id,
      child: child,
      from: from
    };
  },
  removeAllChilds: function removeAllChilds(id, from) {
    if (from === void 0) {
      from = 'children';
    }

    return {
      type: types.removeAllChilds,
      id: id,
      from: from
    };
  },
  event: function event(id, _event) {
    return {
      type: types.event,
      id: id,
      event: omitBy(_event, isObject)
    };
  }
});

function element(state, _ref) {
  var _objectSpread2, _objectSpread3, _objectSpread4;

  var type = _ref.type,
      payload = _objectWithoutPropertiesLoose(_ref, ["type"]);

  switch (type) {
    case types.addChild:
      return _objectSpread({}, state, (_objectSpread2 = {}, _objectSpread2[payload.from] = state[payload.from].concat([payload.child]), _objectSpread2));

    case types.removeChild:
      return _objectSpread({}, state, (_objectSpread3 = {}, _objectSpread3[payload.from] = state[payload.from].filter(function (item) {
        return item !== payload.child;
      }), _objectSpread3));

    case types.removeAllChilds:
      // It's worth optimizing the already-empty case to preserve referential equality
      // because removeAllChilds is often called idempotently
      return state[payload.from].length === 0 ? state : _objectSpread({}, state, (_objectSpread4 = {}, _objectSpread4[payload.from] = [], _objectSpread4));

    case types.event:
      return _objectSpread({}, state, {
        lastEvent: payload.event
      });

    default:
      return state;
  }
}

export var reducer = base.reducer;